<?php
/*
Simple:Press
TinyMCE Editor plugin upgrade routine
$LastChangedDate: 2015-03-13 11:59:35 -0700 (Fri, 13 Mar 2015) $
$Rev: 12576 $
*/

if (preg_match('#'.basename(__FILE__).'#', $_SERVER['PHP_SELF'])) die('Access denied - you cannot directly call this file');

function sp_tinymce_do_upgrade() {
    if (!sp_is_plugin_active('tinymce-richtext/sp-tinymce-plugin.php')) return;

    $tm = sp_get_option('tinymce');

    $db = $tm['dbversion'];
    if (empty($db)) {
        # make sure its not the db 1 option
        $tmdb = sp_get_option('tinymcedb');
        $db = (empty($tmdb)) ? 0 : $tmdb;
    }

    # quick bail check
    if ($db == SPTMDB ) return;

    # apply upgrades as needed

    # db version upgrades
    if ($db < 1) {
        # Check if already exists - i.e, this is an upgrade
    	$tbmeta = sp_get_sfmeta('tinymce_toolbar', 'default');
    	if (!empty($tbmeta)) {
    		# Can't be helped - we will have to remove the old versions first
        	$tb = sp_get_sfmeta('tinymce_toolbar');
        	if ($tb) {
        		foreach($tb as $t) {
        			sp_delete_sfmeta($t['meta_id']);
        		}
        	}
    	}

		# Unserialise again for the last time!
		$tm = unserialize($tm);

		# Correct the double serialisation of the tinymce options
		# and remove the old preview button
		$tm['plugins']		= str_replace(',preview', '', $tm['plugins']);
		$tm['buttons1add']	= str_replace(',preview', '', $tm['buttons1add']);
	}

    if ($db < 2) {
        $tmdb = sp_get_option('tinymcedb');
        if (!empty($tmdb)) sp_delete_option('tinymcedb');
    }

    if ($db < 3) {
    	$tm['plugins']		= $tm['plugins'].',wordpress,wpdialogs,sphelp';
    	$tm['buttons1']		= $tm['buttons1'].$tm['buttons1add'].',|,wp_adv,sp_help';
    	$tm['buttons2']		= $tm['buttons2'].$tm['buttons2add'].',|,formatselect,|,justifyleft,justifycenter,justifyright,justifyfull,|,removeformat';
    	$tm['skin']			= 'o2k7';
    	$tm['variant']		= '';

        unset($tm['buttons1add']);
        unset($tm['buttons2add']);
        unset($tm['lang']);
        unset($tm['rtl']);
    }

    if ($db < 4) {
        # upgrade for wp updating tinymce to 4.x

        # clean up plugins
    	$parts = explode(',', $tm['plugins']);

        # remove old plugins
        while (($i = array_search('inlinepopups', $parts)) !== false) unset($parts[$i]);
        while (($i = array_search('spellchecker', $parts)) !== false) unset($parts[$i]);
        while (($i = array_search('wordpress', $parts)) !== false) unset($parts[$i]);
        while (($i = array_search('wpdialogs', $parts)) !== false) unset($parts[$i]);

        # add in new plugins
        $parts[] = 'link';
        $parts[] = 'textcolor';
        $parts[] = 'charmap';
        $parts[] = 'code';
        $parts[] = 'image';

        $tm['plugins'] = trim(implode(' ', $parts), ' ');

        # clean up toolbar 1
    	$parts = explode(',', $tm['buttons1']);

        # remove old toolbar 1 items
        while (($i = array_search('wp_adv', $parts)) !== false) unset($parts[$i]);
        while (($i = array_search('spellchecker', $parts)) !== false) unset($parts[$i]);
        while (($i = array_search('selectall', $parts)) !== false) unset($parts[$i]);
        while (($i = array_search('pasteword', $parts)) !== false) unset($parts[$i]);

        # rename some toolbar items
        while (($i = array_search('justifyleft', $parts)) !== false) $parts[$i] = 'alignleft';
        while (($i = array_search('justifycenter', $parts)) !== false) $parts[$i] = 'aligncenter';
        while (($i = array_search('justifyright', $parts)) !== false) $parts[$i] = 'alignright';
        while (($i = array_search('justifyfull', $parts)) !== false) $parts[$i] = 'alignjustify';
        while (($i = array_search('sp_help', $parts)) !== false) $parts[$i] = 'sphelp';

        $tm['buttons1'] = str_replace('| |', '|', trim(implode(' ', $parts), ' |'));

        # clean up toolbar 2
    	$parts = explode(',', $tm['buttons2']);

        # remove old toolbar 1 items
        while (($i = array_search('wp_adv', $parts)) !== false) unset($parts[$i]);
        while (($i = array_search('spellchecker', $parts)) !== false) unset($parts[$i]);
        while (($i = array_search('selectall', $parts)) !== false) unset($parts[$i]);
        while (($i = array_search('pasteword', $parts)) !== false) unset($parts[$i]);

        # rename some toolbar items
        while (($i = array_search('justifyleft', $parts)) !== false) $parts[$i] = 'alignleft';
        while (($i = array_search('justifycenter', $parts)) !== false) $parts[$i] = 'aligncenter';
        while (($i = array_search('justifyright', $parts)) !== false) $parts[$i] = 'alignright';
        while (($i = array_search('justifyfull', $parts)) !== false) $parts[$i] = 'alignjustify';
        while (($i = array_search('sp_help', $parts)) !== false) $parts[$i] = 'sphelp';

        $tm['buttons2'] = str_replace('| |', '|', trim(implode(' ', $parts), ' |'));

        unset($tm['skin']);
        unset($tm['variant']);
    }

    if ($db < 2) {
        unset($tm['relative']);
    }

    # save data
    # save data
    $tm['dbversion'] = SPTMDB;
    sp_update_option('tinymce', $tm);
}
